﻿using System;
using System.Data;
using System.Text;
using System.Threading;
using System.Collections;
using System.Collections.Generic;

using Xoa.Virtual.Users;
using Xoa.Virtual.Jobs;
using Xoa.Virtual.Corporations;
using Xoa.Virtual.Rooms;
using Ion.Storage;
using Xoa;

namespace Xoa.Managers
{
    public static class jobManager
    {
        public static Hashtable _Jobs = new Hashtable();
        public static Hashtable _Corps = new Hashtable();

        public static void Init()
        {
            DataColumn dCol;
            using (DatabaseClient dbClient = Eucalypt.dbManager.GetClient())
            {
                dCol = dbClient.getColumn("SELECT id FROM jobs_ranks");
            }
            int[] IDs = dataHandling.dColToArray(dCol, null);
            for (int i = 0; i < IDs.Length; i++)
            {
                virtualJob Job = new virtualJob(IDs[i]);
                _Jobs.Remove(IDs[i]);
                _Jobs.Add(IDs[i], Job);
            }
            DataColumn dLol;
            using (DatabaseClient dbClient = Eucalypt.dbManager.GetClient())
            {
                dLol = dbClient.getColumn("SELECT id FROM jobs_corps");
            }
            int[] CorpIDs = dataHandling.dColToArray(dLol, null);
            for (int i = 0; i < CorpIDs.Length; i++)
            {
                virtualCorporation Corp = new virtualCorporation(CorpIDs[i]);
                _Corps.Remove(CorpIDs[i]);
                _Corps.Add(CorpIDs[i], Corp);
            }
            Out.WriteLine("Job And Corporation System Loaded Successfully");
        }

        public static virtualCorporation getCorp(int ID)
        {
            try { return (virtualCorporation)_Corps[ID]; }
            catch { return null; }
        }

        public static virtualJob getJob(int ID)
        {
            try { return (virtualJob)_Jobs[ID]; }
            catch { return null; }
        }
    }
}
